=begin
#SPX: CaseManager

#No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

OpenAPI spec version: 1.1.1

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.4

=end

require 'date'

module CasemanagerClient
  class WorkflowTask
    attr_accessor :id

    # The name of the task. The logical operator tasks \"OR\" is also indicated by the name field.  When a task is named \"OR\", the task represents the \"OR\" logical operation for all parent tasks. This means that only one parent task is required to be completed before children tasks may be started. 
    attr_accessor :name

    # Attributes of Case Items that are directly related to this workflow task.
    attr_accessor :case_items

    # Other workflow tasks that come immediately before this task in the workflow. No parents IDs indicates this is the first task in a workflow. Workflows can branch and those branches can later rejoin. Multiple parent IDs indicate the rejoining of a branch.  When multiple parent IDs are present, it defaults to AND logic. That means all parent task are required to be completed before this task may be started.  When a task has a name of \"OR\" and has multiple parent IDs, it is specifying that only one of the parent tasks needs to be completed before children tasks may be started. 
    attr_accessor :parent_ids

    # Is this task an important task in the workflow? Could be used when generating a visual timeline of the workflow.
    attr_accessor :key_task

    # When this task was started. If null, the task has not been started. If `started_at` has a value, and `completed_at` does not, the task is currently in progress
    attr_accessor :started_at

    # When this task was completed
    attr_accessor :completed_at

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'name' => :'name',
        :'case_items' => :'case_items',
        :'parent_ids' => :'parent_ids',
        :'key_task' => :'key_task',
        :'started_at' => :'started_at',
        :'completed_at' => :'completed_at'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'Integer',
        :'name' => :'String',
        :'case_items' => :'Array<CaseItem>',
        :'parent_ids' => :'Array<Integer>',
        :'key_task' => :'BOOLEAN',
        :'started_at' => :'DateTime',
        :'completed_at' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'case_items')
        if (value = attributes[:'case_items']).is_a?(Array)
          self.case_items = value
        end
      end

      if attributes.has_key?(:'parent_ids')
        if (value = attributes[:'parent_ids']).is_a?(Array)
          self.parent_ids = value
        end
      end

      if attributes.has_key?(:'key_task')
        self.key_task = attributes[:'key_task']
      end

      if attributes.has_key?(:'started_at')
        self.started_at = attributes[:'started_at']
      end

      if attributes.has_key?(:'completed_at')
        self.completed_at = attributes[:'completed_at']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @case_items.nil?
        invalid_properties.push('invalid value for "case_items", case_items cannot be nil.')
      end

      if @parent_ids.nil?
        invalid_properties.push('invalid value for "parent_ids", parent_ids cannot be nil.')
      end

      if @key_task.nil?
        invalid_properties.push('invalid value for "key_task", key_task cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @name.nil?
      return false if @case_items.nil?
      return false if @parent_ids.nil?
      return false if @key_task.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          case_items == o.case_items &&
          parent_ids == o.parent_ids &&
          key_task == o.key_task &&
          started_at == o.started_at &&
          completed_at == o.completed_at
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, case_items, parent_ids, key_task, started_at, completed_at].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CasemanagerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
